/*
	eid-3g.c

	EID for 3G AMR characterization

	Contact:
		Nobuhiko Naka
		NTT DoCoMo, Inc.
		nob@spg.yrp.nttdocomo.co.jp
*/


#include <stdio.h>
#include <stdlib.h>

#define MAX_SERIAL 244
#define SERIAL_FRAMESIZE (1+MAX_SERIAL+5)

void main(int argc, char *argv[])
{

  short spch[SERIAL_FRAMESIZE];
  short epat[SERIAL_FRAMESIZE];
  short werr[SERIAL_FRAMESIZE];
  
  FILE *fsp, *fep, *fwe;

  int i;
  int skip;
  int frame;

  if(argc!=5) {
    fprintf(stderr, "Usage: eid_utra [speech(i)] [errpat(i)] [speech w/ err(o)] [position]\n");
    exit(1);
  }

  if((fsp=fopen(argv[1], "rb"))==NULL) { perror(argv[1]); exit(1);}
  if((fep=fopen(argv[2], "rb"))==NULL) { perror(argv[2]); exit(1);}
  if((fwe=fopen(argv[3], "wb"))==NULL) { perror(argv[3]); exit(1);}
  sscanf(argv[4],"%d", &skip);
  if(skip<0) {
    fprintf(stderr, "Error: Wrong number. (%d)\n", skip);
    exit(1);
  }
  
  frame=0;

  printf("%d\n", skip);
  for(i=0; i<skip; i++) {
    if(fread(epat, sizeof(short), SERIAL_FRAMESIZE, fep)!=SERIAL_FRAMESIZE){
      fprintf(stderr, "Error: file short.\n");
      exit(1);
    }
  }    

  while(fread(spch, sizeof(short), SERIAL_FRAMESIZE, fsp)==SERIAL_FRAMESIZE){
    if(fread(epat, sizeof(short), SERIAL_FRAMESIZE, fep)!=SERIAL_FRAMESIZE){
			fseek(fep, 0L, SEEK_SET);
			if(fread(epat, sizeof(short), SERIAL_FRAMESIZE, fep)!=SERIAL_FRAMESIZE){
				fprintf(stderr, "Error: Error pattern file read\n");
				exit(1);
			}
    }

    for(i=0; i<SERIAL_FRAMESIZE; i++)  werr[i]=0;

    /* RX_TYPE */
    werr[0]=epat[0];

    for(i=0; i<MAX_SERIAL; i++)  werr[i+1] = spch[i+1]^epat[i+1];

    werr[1+MAX_SERIAL]=epat[1+MAX_SERIAL];

    fwrite(werr, sizeof(short), SERIAL_FRAMESIZE, fwe);
    frame++;
  }

  fclose(fsp);
  fclose(fep);
  fclose(fwe);

  exit(0);

}
